
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v13'
	--     html, script.name -       
	usd.setstatus(script.name)
	local dirUrl
	script.tmp={}

	origUrl = origUrl:gsub('/%w%w(/files/)','%1')

	local page = usd.get(origUrl)
	--         page
  	debugSaveInc(logpref..'.html', page)
  	--    ,     .

  	if page:find('<span class="html_download_api-not_exists">',1,true) then
  		-- 1 -  , true -  plain text
  		usd.setretresult('%notfound%')
  		return
  	end

	usd.waittime(math.random(2))
	-- 1-2 
	page = usd.post(usd.getlocation(), 'gateway_result=1')
	--  
  	debugSaveInc(logpref..'.html', page)

  	if page:find('<span class="html_download_api-not_exists">',1,true) then
  		usd.setretresult('%notfound%')
  		return
  	end

  	if page:find('<span class="html_download_api-limit_parallel">',1,true) then
  		usd.setretresult('%simultaneous_downloads_limit')
  		return
  	end

	local wait = string.match(page, '<span class="html_download_api%-limit_interval">(%d+)</span>')
		or page:match('<div class="ipbg">%s*<strong>[^<]- (%d+)')
	--      
	if wait then
		wait = tonumber(wait)
		if wait > 60 then
			usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
			--  USD ,   "%" -   
			return
		end
		usd.waittime(wait+math.random(1,3))
		page = usd.post(usd.getlocation(), 'gateway_result=1')
		debugSaveInc(logpref..'.html', page)
	end

	wait = string.match(page, '<span id="download_waiter_remain">(%d+)</span>')
	--     
	if not wait then
		--   ,   ...
		local err = page:match('<div class="ipbg">%s*<p>%s*<strong>.-</strong>')
		if err then
			err = err:gsub('%s*<br/>%s*', ' ')
			err = utf8ToAnsi(err)
			usd.setretresult('%' .. err)
			return
		end

		usd.setretresult('%plugindefect no wait')
		return
	end
	usd.waittime(wait)

	local key = page:match("Recaptcha.create%('([^']+)'")
	local resp, _ , chall
	local fid = string.match(page, '<td class="repeat"><a href="([^"]+)"')
	if not fid:find('http://',1,true) then fid = 'http://depositfiles.com' .. fid end

function getNewName(str)
	--    
	local tmp = str:match('/([^/]+)$')
	tmp = unescape(tmp)
	script.tmp.newName = utf8ToAnsi(tmp)
end

	if fid:find('/auth-',1,true) then
		getNewName(fid)
		usd.waittime(math.random(3,5))
		usd.setretresult(fid, 1, 1)
		return
	end

	for i=1, captchaAttempts do
		resp, _ , chall = queryReCaptcha(key)
		page = usd.get(fid .. '&challenge=' .. chall .. '&response=' .. resp)
  		debugSaveInc(logpref..'.html', page)
  		if not page:find('load_recaptcha()',1,true) then break end
  	end

  	if page:find('load_recaptcha()',1,true) then return usd.setretresult('%Wrong captcha?') end

	usd.waittime(math.random(3))

	local dirUrl = page:match("window.location.href%s*=%s*'(http://fileshare[^']+)'")
	getNewName(dirUrl)

	--  USD  ,       .
	--usd.setretresult(page:match('action="([^"]+)"') .. '?|1|1')
	usd.setretresult(dirUrl .. '?',1,1)
	return
end


--        ,
--       PlgOnSuccess
function OS(origUrl, dirUrl, fullName)
	local newName = fileRename(fullName, script.tmp.newName)
	-- fileRename       / 

	usd.setretresult(newName)
	return
end

regDirSuccess('//depositfiles.com/', GDL, OS)
regDirSuccess('//depositfiles.org/', GDL, OS)
regDirSuccess('//dfiles.ru/', GDL, OS)
--     '//depositfiles.com/' 
--     -  GDL - 
-- ,      - OS
